<template>
  <modal class="arcticmodal-container full-viewport"
         name="restore-password"
         height="auto"
         :minWidth="300"
         :resizable="true"
         :adaptive="true"
         :reset="true"
         :delay="1"
         @before-open="$helpers.noscroll(true)"
         @before-close="$helpers.noscroll(false)"
         @closed="dynamicComponent = 'restore-form'"
  >
    <div id="forgot-password-modal" class="forgot-password-modal">
      <div class="container m-header">
        <div @click="close()" class="box-modal_close arcticmodal-close"></div>
        <div class="row">
          <div class="column">
            <h3>Восстановить пароль</h3>
          </div>
        </div>
      </div>
      <div class="container password-restore">
        <component :is="dynamicComponent"
                   @methodIsChoosen="addRestoreMethod"
                   v-model="dataForRestore"
                   @restore="doRestorePassword"
                   :inicial="inicial"
                   class="feedback-block"/>
        <success-message></success-message>
      </div>
    </div>
    <modal-info></modal-info>
  </modal>
</template>

<script>
  import ModalInfo from '@/components/Modals/ModalInfo'
  import RestoreForm from '@/pages/Login/RestorePassword/RestoreForm'
  import NewPassword from '@/pages/Login/RestorePassword/NewPassword'
  import EmailSent from '@/pages/Login/RestorePassword/EmailSent'
  import SmsLoginPassword from '@/pages/Login/RestorePassword/SmsLoginPassword'
  import ChooseRestoreMethod from '@/pages/Login/RestorePassword/ChooseRestoreMethod'
  import SmsCode from '@/pages/Login/RestorePassword/SmsCode'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'

  export default {
    components: {
      ModalInfo,
      RestoreForm,
      EmailSent,
      SmsLoginPassword,
      ChooseRestoreMethod,
      SmsCode,
      SuccessMessage,
      WarningMessage,
      NewPassword
    },
    data () {
      return {
        dataForRestore: null,
        // dynamicComponent: 'NewPassword',
        dynamicComponent: 'restore-form',
        codesToComponents: {
          'emailWithRestoreLinkSuccessfullySend': 'email-sent',
          'restoreMethodDoesNotChosen': 'choose-restore-method',
          'smsSended': 'sms-code',
          'smsSendedLoginPassword': 'sms-login-password'
        },
        inicial: {
          token: '',
          tokenExpired: '',
          userId: ''
        }
      }
    },
    methods: {
      addRestoreMethod (method) {
        console.log('add restore method', method);
        this.dataForRestore = {...this.dataForRestore, ...method};
        this.doRestorePassword(this.dataForRestore)
      },
      doRestorePassword: async function (dataForRestore) {
          if (dataForRestore.login[0] === '8' && dataForRestore.login[1] === '(') {
            let phone = this.dataForRestore.login.match(/\d/g).join('');
            dataForRestore.login = phone.replace('8', '7')
          }


          this.BUTTON_LOADING(true);
          this.$backend.api.user.password.restore(dataForRestore).then(({data}) => {
            if (dataForRestore.restoreMethod === 'sms' && !dataForRestore.smsCode) {
              this.$toastr.success('Код подтверждения отправлен на Ваш номер телефона', 'Успешно');
            }

            if (this.codesToComponents[data.data.code]) {
              this.dynamicComponent = this.codesToComponents[data.data.code];
            } else {
              if (dataForRestore.restoreMethod === 'sms' && dataForRestore.smsCode !== '') {
                this.inicial.token = data?.data?.token;
                this.inicial.tokenExpired = data?.data?.tokenExpired;
                this.inicial.userId = data?.data?.userId;
                this.dynamicComponent = 'NewPassword'
              } else {
                this.$store.commit('AUTH_SUCCESS', {data: data.data, authState: 'authorized'});
                this.$toastr.success('Вы вошли в личный кабинет.', 'Успешно');
                const promises = [];
                promises.push(this.$methods.user.getUserData());
                promises.push(this.$methods.loan.getLoans());

                return Promise.all(promises).then(() => {
                  this.$router.push({name: 'my-loan'});
                }).catch((e) => {
                  this.$toastr.warning('Войдите используя пароль');
                  this.$router.push({name: 'login'})
                });
              }
            }

          }).catch( (e) => {

            if (Array.isArray(e.errors)) {
            	this.$error(e.errors, {
					spamProtectionRestriction: 'Превышен лимит запросов отправки смс. Используйте E-mail или подождите.',
					userNotHaveLoans: 'Личный кабинет не активен. Пройдите регистрацию заново',
					smsCodeInvalid: 'Неверный код',
					restoreUserNotFound: 'Пользователь с указанными данными не найден',
                }, 'Произошла ошибка на сервере. Вы можете обратиться в службу поддержки для восстановления пароля');
              } else {
            	this.$toastr.error('Произошла ошибка на сервере. Вы можете обратиться в службу поддержки для восстановления пароля');
            }
          }).finally(() => {
            this.BUTTON_LOADING(false);
          })
      },
      close: function () {
        this.$modal.hide('restore-password')
      }
    },
    name: 'restore-password'
  }
</script>

<style lang="scss" scoped>
  @import "static/css/variables/media.scss";

  @media #{$mobile} {
    .feedback-block {
      padding: 105px 0 0 !important;
    }
  }

  .box-modal {
    margin: 0;
  }

  .v--modal-overlay .v--modal-box {
    border-radius: 10px
  }

  form {
    margin-bottom: 0
  }

  .tabs__content {
    display: block
  }
  .password-restore {
    & input {
      margin-bottom: 40px;
    }
  }
</style>
